.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
include msvcrt.inc
includelib msvcrt.lib
.data
inputStatement db "Enter Number or command(0: dequeue, other number: number to be enqueued in the queue) : ", 0
numberFormat db "%d", 0
outputFormat db "dequeue %d", 10, 0

space dd 11 dup(?) ; queue
enqueueErrorStatement db "ERROR THE QUEUE IS FULL", 10, 0
dequeueErrorStatement db "ERROR THE QUQUE IS EMPTY", 10, 0

queuelength dd 10, 0 ; queue length
nextempty dd 11, 0 ; point to the end of queue
front dd 11, 0 ; point to the end of queue
inputnumber dd "%d", 0 ; hold the input number

.code
start:
	mov EBP, offset space + 11 * 4 ; Move end address(large address) of space to EBP
	jmp input ; jmp to input

input:
	invoke crt_printf, addr inputStatement
	invoke crt_scanf, addr numberFormat, addr inputnumber
	mov ECX, inputnumber ; load the inputnumber to ECX
	cmp ECX, 0 ; 0 is dequeue, other number is enqueue
	je dequeue ; jump to dequeue
	jmp enqueue ; jump to enqueue

enqueue:
	mov EAX, nextempty ; load the nextempty pointer to EAX 
	mov EBX, front ; load the front pointer to EAX 
	mov ECX, queuelength 
	mov EDX, inputnumber
	add EBX, 1 ; see if queue is full(nextempty = front + 1)
	cmp EAX, EBX ; see if queue is full(nextempty = front + 1)
	je enqueueError ; if queue is full, jump to enqueueError
	sub EBX, 1 ; see if queue is full(nextempty = front ?queuelength )
	sub EBX, queuelength ; see if queue is full(nextempty = front ?queuelength)
	cmp EAX, EBX ; see if queue is full(nextempty = front ?queuelength)
	je enqueueError ; if queue is full, jump to enqueueError
	mov [EBP - 4 * 11 + 4 * EAX - 4], EDX ; enqueue the inputnumber to queue in memory
	sub EAX, 1 ; sub the nextempty pointer
	mov nextempty, EAX ; store the pointer to memory
	cmp EAX, 0 ; see if the pointer is out of bound
	je nextemptybacktobegin ; if the pointer is out of bound, move back to the start point
	jmp input

dequeue:
	mov EAX, nextempty
	mov EBX, front 
	mov ECX, queuelength 
	cmp EAX, EBX ; see if queue is empty(nextempty = front + 1)
	je dequeueError ; if queue is empty, jump to enqueueError
	mov EDX, [EBP - 4 * 11 + 4 * EBX - 4] ; get the front data of the queue, and load it to ECX
	invoke crt_printf, addr outputFormat, EDX ; print the front data of the queue, and load it to ECX
	mov EBX, front 
	sub EBX, 1 ; sub the front pointer
	mov front, EBX ; store the pointer to memory
	cmp EBX, 0 ; see if the pointer is out of bound
	je frontbacktobegin ; if the pointer is out of bound, move back to the start point
	jmp input

nextemptybacktobegin:
	mov EBX, 11
	mov nextempty, EBX
	jmp input

frontbacktobegin:
	mov EBX, 11
	mov front, EBX
	jmp input

enqueueError:
	invoke crt_printf, addr enqueueErrorStatement
	jmp exitprogram

dequeueError:
	invoke crt_printf, addr dequeueErrorStatement
	jmp exitprogram

exitprogram:
	invoke ExitProcess, NULL

end start